﻿Imports MySql.Data.MySqlClient
Imports System.IO

Public Class frmBckup
    Friend WithEvents myScript As MySql.Data.MySqlClient.MySqlScript
    Private DBServer As String
    Private DBDatabase As String
    Private DBServerPort As String
    Private DBUser As String
    Private DBPass As String
    Private MyConString As String
    Private q As Integer = 1
    Private saveFile As String
    Private item As ListViewItem
    Private stringItem As String = Nothing
    Private query As String = ""
    Private tablesArray As New ArrayList()
    Dim objWriter As IO.StreamWriter
    Sub BackupMySql_Table()
        lstBancos.Enabled = False
        stringItem = "Iniciando Processo...."
        item = New ListViewItem(New String() {stringItem})
        'lstProcesso.Items.Add(item).ForeColor = Color.Red
        lblProcesso.Text = stringItem
        Application.DoEvents()
        Dim ftphost As String = "bckup"
        saveFile = AbrirArquivoSQL(False)
        DBServer = txtHost.Text
        DBServerPort = "3306"
        DBDatabase = lstBancos.FocusedItem.Text
        DBUser = txtUsuario.Text
        DBPass = txtSenha.Text
        MyConString = "SERVER=" & DBServer & ";DATABASE=" & DBDatabase & ";UID=" & DBUser & ";PASSWORD=" & DBPass & ";Allow Zero Datetime=True"
        Dim connection As New MySqlConnection(MyConString)
        Dim tablesCommand As MySqlCommand = connection.CreateCommand()
        Dim rowsCommand As MySqlCommand = connection.CreateCommand()
        Dim tablesReader As MySqlDataReader
        Dim rowsReader As MySqlDataReader

        If File.Exists(saveFile) Then
            File.Delete(saveFile)
        End If

        stringItem = "Explorando tabelas do banco " & DBDatabase
        item = New ListViewItem(New String() {stringItem})
        'lstProcesso.Items.Add(item).ForeColor = Color.Red
        lblProcesso.Text = stringItem
        Application.DoEvents()
        tablesCommand.CommandText = "SELECT `TABLE_NAME` AS Tabela FROM `information_schema`.TABLES  WHERE TABLE_SCHEMA = '" & DBDatabase & "' AND TABLE_TYPE = 'BASE TABLE';"
        connection.Open()
        tablesReader = tablesCommand.ExecuteReader()
        Dim j As Integer = 0
        While tablesReader.Read()
            lstTabelas.Items(j).Selected = True
            If lstTabelas.Items(j).Checked = True Then
                stringItem = "Adicionando a tabela " & tablesReader.GetValue(0).ToString() & " ao Processo"
                item = New ListViewItem(New String() {stringItem})
                'lstProcesso.Items.Add(item).ForeColor = Color.Red
                lblProcesso.Text = stringItem
                tablesArray.Add(tablesReader.GetValue(0).ToString())
                lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                Application.DoEvents()
            End If
            j += 1
        End While
        tablesReader.Close()
        stringItem = "Total de tabelas a processar " & tablesArray.Count
        item = New ListViewItem(New String() {stringItem})
        'lstProcesso.Items.Add(item).ForeColor = Color.Red
        lblProcesso.Text = stringItem
        lblInfo.Visible = True
        lblInfo.Text = "Processando...Aguarde!!!"
        Cursor.Current = Cursors.WaitCursor
        Application.DoEvents()

        objWriter = New System.IO.StreamWriter(saveFile)
        objWriter.Write(query)
        query += "/*<>*/" & vbNewLine
        query += "CREATE DATABASE /*!32312 IF NOT EXISTS*/ `" & DBDatabase & "`/*!40100 DEFAULT CHARACTER SET latin1 */;" & vbNewLine
        query += "/*<>*/" & vbNewLine
        query += "USE `" & DBDatabase & "`;" & vbNewLine

        For i = 0 To tablesArray.Count - 1
            stringItem = "Montando estrutura da tabela " & tablesArray(i)
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            Application.DoEvents()
            query += "/*<>*/" & vbNewLine
            query += "DROP TABLE IF EXISTS `" & tablesArray(i) & "`;" & vbCrLf '& Database & "."

            stringItem = "DROP TABLE IF EXISTS `" & tablesArray(i)
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
            Application.DoEvents()

            item = New ListViewItem(New String() {stringItem})
            'lstProcesso.Items.Add(item).ForeColor = Color.Red
            lblProcesso.Text = stringItem

            Application.DoEvents()

            Dim SHOWCREATE As String = "SHOW CREATE TABLE `" & tablesArray(i) & "`;"
            stringItem = "Executando o comando " & SHOWCREATE
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
            Application.DoEvents()

            item = New ListViewItem(New String() {stringItem})
            'lstProcesso.Items.Add(item).ForeColor = Color.Red
            lblProcesso.Text = stringItem

            Dim ShowCreateCommand As MySqlCommand = connection.CreateCommand()
            ShowCreateCommand.CommandText = SHOWCREATE
            Dim ShowCreateReader As MySqlDataReader
            ShowCreateReader = ShowCreateCommand.ExecuteReader

            While ShowCreateReader.Read
                query += "/*<>*/" & vbNewLine
                query += ShowCreateReader.GetString(1)
            End While

            ShowCreateReader.Close()
            query += ";" & vbCrLf

            stringItem = "Iniciando busca dos dados da tabela " & tablesArray(i)
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
            Application.DoEvents()

            item = New ListViewItem(New String() {stringItem})
            'lstProcesso.Items.Add(item).ForeColor = Color.Red
            lblProcesso.Text = stringItem


            stringItem = "SELECT * FROM " & tablesArray(i)
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red

            Application.DoEvents()

            item = New ListViewItem(New String() {stringItem})
            'lstProcesso.Items.Add(item).ForeColor = Color.Red
            lblProcesso.Text = stringItem
            Dim contaRegistros As MySqlDataReader
            Dim RegistrosAffected As Integer
            Dim maxRegistroAffected As Integer
            rowsCommand.CommandText = "SELECT COUNT(*) AS REGISTROS FROM `" & tablesArray(i) & "`"
            contaRegistros = rowsCommand.ExecuteReader

            While contaRegistros.Read
                RegistrosAffected = CInt(contaRegistros("REGISTROS").ToString)
            End While
            If RegistrosAffected > 0 Then
                maxRegistroAffected = System.Math.Round((CInt(RegistrosAffected / 300)), 0, MidpointRounding.ToEven)
            End If
            contaRegistros.Close()

            rowsCommand.CommandText = "SELECT * FROM `" & tablesArray(i) & "`"
            rowsReader = rowsCommand.ExecuteReader()

            stringItem = "INSERT INTO `" & tablesArray(i) & " ..."
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
            Application.DoEvents()
            Dim pegou As Boolean = False
            Dim n As Integer = 0
            Dim contaMaxRegistros As Integer = 300

            While rowsReader.Read()
                item = New ListViewItem(New String() {stringItem})
                'lstProcesso.Items.Add(item).ForeColor = Color.Red
                lblProcesso.Text = stringItem
                If pegou = False Then
                    query += "/*<>*/" & vbNewLine
                    query += "INSERT INTO `" & Replace(tablesArray(i), "`", "") & "` ("
                Else
                    If maxRegistroAffected > 1 Then
                        If contaMaxRegistros = 0 Then
                            'query += "INSERT INTO `" & tablesArray(i) & "` ("
                            contaMaxRegistros = 300
                        ElseIf contaMaxRegistros > 0 Then
                            'query += "INSERT INTO `" & tablesArray(i) & "` ("
                            contaMaxRegistros -= 1
                        End If

                    End If
                End If
                Dim count As Integer = rowsReader.FieldCount - 1
                Dim keys(count) As String
                Dim values(count) As String
                'lstProcesso.EnsureVisible(lstProcesso.Items.Count - 1)

                lblProcesso.Text = stringItem
                Application.DoEvents()
                For n = 0 To count
                    keys(n) = rowsReader.GetName(n)
                    If rowsReader.GetDataTypeName(n).ToString = "DATETIME" Or rowsReader.GetDataTypeName(n).ToString = "DATE" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = IIf(IsDBNull(rowsReader.Item(n)) = True, "0000-00-00", rowsReader.Item(n)).ToString
                        Else
                            If rowsReader.Item(n).ToString = "00/00/0000 00:00:00" Then
                                values(n) = "1900-01-01 00:00:00"
                            Else
                                values(n) = Format(CDate(Replace(rowsReader.Item(n).ToString, "/", "-")), "yyyy-MM-dd hh:mm:ss").ToString
                            End If
                        End If
                    ElseIf rowsReader.GetDataTypeName(n).ToString = "VARCHAR" Then
                        values(n) = rowsReader.Item(n).ToString
                    ElseIf rowsReader.GetDataTypeName(n).ToString = "INT" Then
                        values(n) = IIf(IsDBNull(rowsReader.Item(n)) = True, 0, rowsReader.Item(n))
                    ElseIf rowsReader.GetDataTypeName(n).ToString = "DOUBLE" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = "0.0"
                        Else
                            values(n) = IIf(IsDBNull(rowsReader.Item(n)) = True, 0, Replace(CDbl(rowsReader.Item(n)), ",", "."))
                        End If

                    ElseIf rowsReader.GetDataTypeName(n).ToString = "TINYINT" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = "0"
                        Else
                            values(n) = Replace(Replace(rowsReader.Item(n), "False", CInt(rowsReader.Item(n))), "True", CInt(rowsReader.Item(n)))
                        End If

                    ElseIf rowsReader.GetDataTypeName(n).ToString = "DECIMAL" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = "0.0"
                        Else
                            values(n) = IIf(IsDBNull(rowsReader.Item(n)) = True, 0, Replace(CDbl(rowsReader.Item(n)), ",", "."))
                        End If
                    ElseIf rowsReader.GetDataTypeName(n).ToString = "FLOAT" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = "0.00000"
                        Else
                            values(n) = rowsReader.Item(n)
                        End If

                    ElseIf rowsReader.GetDataTypeName(n).ToString = "TIME" Then
                        If IsDBNull(rowsReader.Item(n)) = True Then
                            values(n) = IIf(IsDBNull(rowsReader.Item(n)) = True, "00:00:00", rowsReader.Item(n)).ToString
                        Else
                            If rowsReader.Item(n).ToString = "00:00:00" Then
                                values(n) = "00:00:00"
                            Else
                                values(n) = Format(CDate(Replace(rowsReader.Item(n).ToString, "/", "-")), "hh:mm:ss").ToString
                            End If
                        End If
                    Else
                        values(n) = rowsReader.Item(n)
                    End If
                    'lstProcesso.EnsureVisible(lstProcesso.Items.Count - 1)
                    lblProcesso.Text = stringItem
                Next

                If pegou = False Then
                    RegistrosAffected -= 1
                    If RegistrosAffected <= 0 Then
                        query += "`" & Join(keys, "`, `") & "`)" & vbCrLf & "VALUES ('" & Join(values, "', '") & "');" & vbCrLf
                        pegou = True
                    Else
                        query += "`" & Join(keys, "`, `") & "`)" & vbCrLf & "VALUES ('" & Join(values, "', '") & "')," & vbCrLf
                        pegou = True
                    End If
                Else
                    RegistrosAffected -= 1
                    If RegistrosAffected <= 0 Then
                        query += "('" & Join(values, "', '") & "');" & vbCrLf
                    Else
                        If maxRegistroAffected > 1 Then
                            If contaMaxRegistros = 0 Then
                                query += "INSERT INTO `" & tablesArray(i) & "` ("
                                query += "`" & Join(keys, "`, `") & "`)" & vbCrLf & "VALUES ('" & Join(values, "', '") & "')," & vbCrLf
                                'contaMaxRegistros = 300
                            ElseIf contaMaxRegistros > 1 Then
                                query += "('" & Join(values, "', '") & "')," & vbCrLf
                            ElseIf contaMaxRegistros = 1 Then
                                query += "('" & Join(values, "', '") & "');" & vbCrLf
                            End If
                        Else
                            query += "('" & Join(values, "', '") & "')," & vbCrLf
                        End If
                    End If
                End If
                objWriter.Write(query)
                query = Nothing
            End While
            rowsReader.Close()
            query += vbCrLf & vbCrLf
            objWriter.Write(query)
            'lstProcesso.EnsureVisible(lstProcesso.Items.Count - 1)
            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
            lblProcesso.Text = stringItem
            query = Nothing
        Next
        'Rotinas(SP)
        BackupMysql_SP()
        BackupMysql_View()
        lblProcesso.Text = "Processo Concluído ... "
        lblInfo.Text = lblProcesso.Text
        Cursor.Current = Cursors.Default
        Application.DoEvents()
        objWriter.Close()
        objWriter.Dispose()
        connection.Close()
        connection.Dispose()
    End Sub

    Sub RestoreMysql()
        LerArquivoSQL(AbrirArquivoSQL(True))
    End Sub

    Function AbrirArquivoSQL(ByVal tipo As Boolean) As String
        Try
            If tipo = True Then
                Dim AbrirComo As OpenFileDialog = New OpenFileDialog()
                Dim caminho As DialogResult

                AbrirComo.Title = "Abrir como"
                AbrirComo.FileName = "Nome Arquivo"
                AbrirComo.Filter = "Arquivos Textos (*.sql)|*.sql"
                caminho = AbrirComo.ShowDialog
                AbrirArquivoSQL = AbrirComo.FileName

                If AbrirArquivoSQL = Nothing Then
                    MessageBox.Show("Arquivo Inválido", "Abrir Arquivo", MessageBoxButtons.OK)
                Else
                    Return AbrirArquivoSQL
                End If
            Else
                Dim AbrirComo As SaveFileDialog = New SaveFileDialog()
                Dim caminho As DialogResult

                Dim strDate As String = Date.Now.ToShortDateString   'Prepend file with date for dated backups
                Dim fileName As String = lstBancos.FocusedItem.Text & "_" & strDate.Replace("/", "-") & "_" & Now.ToShortTimeString.Replace(":", "_").ToString & ".sql"

                AbrirComo.Title = "Salvar como"
                AbrirComo.FileName = fileName '& ".sql"
                AbrirComo.Filter = "Arquivos Textos (*.sql)|*.sql"
                caminho = AbrirComo.ShowDialog
                AbrirArquivoSQL = AbrirComo.FileName

                If AbrirArquivoSQL = Nothing Then
                    MessageBox.Show("Arquivo Inválido", "Salvar Como", MessageBoxButtons.OK)
                Else
                    Return AbrirArquivoSQL
                End If
            End If
        Catch ex As Exception

        End Try
        Return Nothing
    End Function

    Sub LerArquivoSQL(ByVal arqv As String)
        Dim fluxoTexto As IO.StreamReader
        Dim linhaTexto As String
        Dim Linha As String = Nothing
        Dim Linhas() As String = Nothing
        If IO.File.Exists(arqv) Then
            fluxoTexto = New IO.StreamReader(arqv)
            linhaTexto = fluxoTexto.ReadToEnd
            While linhaTexto <> Nothing
                Linha &= linhaTexto & vbCrLf
                linhaTexto = fluxoTexto.ReadLine
                Linhas = Split(Linha, "/*<>*/")
            End While
            Dim p As Integer
            Dim Con As MySqlConnection = New MySqlConnection(MyConString)
            Dim ShowCreateCommand As MySqlCommand = Con.CreateCommand
            lblInfo.Visible = True
            lblInfo.Text = "Processo de Restauração Iniciado !!!"
            lblProcesso.Text = "Aguarde !!! Iniciado Processo de Restauração"
            Application.DoEvents()
            Cursor.Current = Cursors.WaitCursor
            Dim script As String = Linha

            Try
                myScript = New MySqlScript(script)
                myScript.Connection = Con
                myScript.Execute()
                lblProcesso.Text = "Restauração Concluída !!!"
                lblInfo.Text = lblProcesso.Text
                Application.DoEvents()
            Catch ex As MySqlException
                lblProcesso.Text = ex.Message.ToString
            End Try

            Cursor.Current = Cursors.Default

            For p = 1 To Linhas.Length - 1
                If 1 = 2 Then
                    myScript = New MySqlScript(script)
                    myScript.Connection = Con
                    myScript.Execute()
                Else
                    'ShowCreateCommand.CommandText = Linhas(p)
                    'ShowCreateCommand.ExecuteNonQuery()
                End If
            Next
            fluxoTexto.Close()
        Else
            MessageBox.Show("Arquivo não existe")
        End If
    End Sub

    Sub BackupMysql_SP()
        Dim connection2 As New MySqlConnection(MyConString)
        Dim tablesCommand2 As MySqlCommand = connection2.CreateCommand()
        Dim rowsCommand2 As MySqlCommand = connection2.CreateCommand()
        Dim tablesReader2 As MySqlDataReader

        stringItem = "Criando STORED PROCEDURES "
        item = New ListViewItem(New String() {stringItem})
        lstProgresso.Items.Add(item).ForeColor = Color.Red
        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
        lblProcesso.Text = stringItem
        Application.DoEvents()
        tablesCommand2.CommandText = "SELECT `SPECIFIC_NAME` FROM `information_schema`.`ROUTINES` WHERE ROUTINE_SCHEMA = '" & lstBancos.FocusedItem.Text & "' AND ROUTINE_TYPE = 'PROCEDURE' "
        connection2.Open()
        tablesReader2 = tablesCommand2.ExecuteReader()
        query = ""
        tablesArray = New ArrayList()
        Dim j As Integer = 0
        While tablesReader2.Read()
            For j = 0 To lstTabelas.Items.Count - 1
                lstTabelas.Items(j).Selected = True
                If lstTabelas.Items(j).Checked = True Then
                    If lstTabelas.Items(j).Text.ToUpper = tablesReader2.GetValue(0).ToString().ToUpper Then
                        stringItem = "SHOW CREATE PROCEDURE " & tablesReader2.GetValue(0).ToString()
                        Dim connection3 As New MySqlConnection(MyConString)
                        Dim tablesCommand3 As MySqlCommand = connection3.CreateCommand
                        Dim rowsCommand3 As MySqlCommand = connection3.CreateCommand
                        Dim tablesReader3 As MySqlDataReader
                        tablesCommand3.CommandText = stringItem
                        connection3.Open()
                        query += "/*<>*/" & vbNewLine & vbNewLine
                        tablesReader3 = tablesCommand3.ExecuteReader
                        Dim DROP_PROCEDURES As String = "DROP PROCEDURE IF EXISTS `" & tablesReader2.GetValue(0).ToString() & "` $$"
                        While tablesReader3.Read()
                            Dim zBytes() As Byte
                            If TypeOf tablesReader3.Item("Create Procedure") Is System.Byte() Then
                                zBytes = DirectCast(tablesReader3.Item("Create Procedure"), System.Byte())
                                query = "DELIMITER $$ " & vbNewLine & DROP_PROCEDURES & vbNewLine & System.Text.Encoding.Default.GetString(zBytes) & " $$ " & vbNewLine & "DELIMITER ;" & vbNewLine & vbNewLine
                            Else
                                query = "DELIMITER $$ " & vbNewLine & DROP_PROCEDURES & vbNewLine & tablesReader3.Item("Create Procedure").ToString & " $$ " & vbNewLine & "DELIMITER ;" & vbNewLine & vbNewLine
                            End If
                        End While
                        objWriter.Write(query)
                        query = Nothing

                        item = New ListViewItem(New String() {stringItem})
                        lstProgresso.Items.Add(item).ForeColor = Color.Black
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        lblProcesso.Text = stringItem
                        Application.DoEvents()
                        connection3.Close()
                        connection3.Dispose()
                    End If
                End If
            Next
        End While
        connection2.Close()
        connection2.Dispose()
        lstBancos.Enabled = True
    End Sub

    Sub BackupMysql_View()
        Dim connection2 As New MySqlConnection(MyConString)
        Dim tablesCommand2 As MySqlCommand = connection2.CreateCommand()
        Dim rowsCommand2 As MySqlCommand = connection2.CreateCommand()
        Dim tablesReader2 As MySqlDataReader

        stringItem = "Criando Views "
        item = New ListViewItem(New String() {stringItem})
        lstProgresso.Items.Add(item).ForeColor = Color.Red
        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
        lblProcesso.Text = stringItem
        Application.DoEvents()
        tablesCommand2.CommandText = "SELECT TABLE_NAME AS VIEWS FROM `information_schema`.VIEWS WHERE TABLE_SCHEMA = '" & lstBancos.FocusedItem.Text & "'"
        connection2.Open()
        tablesReader2 = tablesCommand2.ExecuteReader()
        query = ""
        tablesArray = New ArrayList()
        Dim j As Integer = 0
        While tablesReader2.Read()
            For j = 0 To lstTabelas.Items.Count - 1
                lstTabelas.Items(j).Selected = True
                If lstTabelas.Items(j).Checked = True Then
                    If lstTabelas.Items(j).Text.ToUpper = tablesReader2.GetValue(0).ToString().ToUpper Then
                        stringItem = "SHOW CREATE VIEW " & tablesReader2.GetValue(0).ToString()
                        Dim connection3 As New MySqlConnection(MyConString)
                        Dim tablesCommand3 As MySqlCommand = connection3.CreateCommand
                        Dim rowsCommand3 As MySqlCommand = connection3.CreateCommand
                        Dim tablesReader3 As MySqlDataReader
                        tablesCommand3.CommandText = stringItem
                        connection3.Open()
                        query += "/*<>*/" & vbNewLine & vbNewLine
                        tablesReader3 = tablesCommand3.ExecuteReader
                        Dim DROP_PROCEDURES As String = "DROP VIEW IF EXISTS `" & tablesReader2.GetValue(0).ToString() & "` $$"
                        While tablesReader3.Read()
                            Dim zBytes() As Byte
                            If TypeOf tablesReader3.Item("Create View") Is System.Byte() Then
                                zBytes = DirectCast(tablesReader3.Item("Create View"), System.Byte())
                                query = "DELIMITER $$ " & vbNewLine & DROP_PROCEDURES & vbNewLine & System.Text.Encoding.Default.GetString(zBytes) & " $$ " & vbNewLine & "DELIMITER ;" & vbNewLine & vbNewLine
                            Else
                                query = "DELIMITER $$ " & vbNewLine & DROP_PROCEDURES & vbNewLine & tablesReader3.Item("Create View").ToString & " $$ " & vbNewLine & "DELIMITER ;" & vbNewLine & vbNewLine
                            End If
                        End While
                        objWriter.Write(query)
                        query = Nothing

                        item = New ListViewItem(New String() {stringItem})
                        lstProgresso.Items.Add(item).ForeColor = Color.Black
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        lblProcesso.Text = stringItem
                        Application.DoEvents()
                        connection3.Close()
                        connection3.Dispose()
                    End If
                End If
            Next


        End While
        connection2.Close()
        connection2.Dispose()
        lstBancos.Enabled = True
    End Sub

    Private Sub frmBckup_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim campos, condicao As String
        campos = ""
        condicao = ""

        'CRIAR AQUI ROTINAS PARA CARREGAR E MONTAR OS LISTVIEW
        'O LISTVIEW LSTBANCOS DEVE TER COMO CONTEUDO AS BASES DO BANCO
        'O LISTVIEW LSTTABELAS DEVE CONTER AS TABELAS DO BANCO SELECIONADO NO LSTBANCO
        'O LISTVIEW LSTPROGRESSO IRA INFORMAR AO USUARIO O PROGRESSO DO PROCESSO

        Dim Vetores1()() As String = {New String() {"Tabelas"}, New String() {"265"}}
        criaList(campos, condicao, lstTabelas, True, Vetores1, False)

        Dim Vetores2()() As String = {New String() {"Bancos"}, New String() {"155"}}
        criaList(campos, condicao, lstBancos, False, Vetores2, False)

        Dim Vetores3()() As String = {New String() {"Progresso"}, New String() {"408"}}
        criaList(campos, condicao, lstProgresso, False, Vetores3, False)

        'Dim Vetores4()() As String = {New String() {"Processo"}, New String() {"300"}}
        'criaList(campos, condicao, lstProcesso, False, Vetores4, False)

        lstProgresso.View = View.Details
        txtHost.Text = "localhost"
        txtUsuario.Text = "root"

    End Sub

    Private Sub btnLogoff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'fechar conexão com servidor
    End Sub

    Private Sub btnIniciarBKP_Click(sender As System.Object, e As System.EventArgs) Handles btnIniciarBKP.Click
        Try
            Dim i As Integer
            Dim temobjeto As Boolean = False
            For i = 0 To lstTabelas.Items.Count - 1
                lstTabelas.Items(i).Selected = True
                If lstTabelas.Items(i).Checked = True Then
                    temobjeto = True
                End If
            Next
            If temobjeto = False Then
                MessageBox.Show("Não foi selecionado nenhum objeto para bakcup" & vbNewLine & "Selecione ao menos um objeto para iniciar um bakcup", "Backup", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If
            lblInfo.Visible = False
            BackupMySql_Table()
            lblInfo.Visible = False
        Catch ex As Exception
            'Trata erro aqui.
        End Try
    End Sub

    Private Sub btnConectar_Click(sender As System.Object, e As System.EventArgs) Handles btnConectar.Click
        Try
            lstBancos.Items.Clear()
            'lstProcesso.Items.Clear()
            lstProgresso.Items.Clear()
            lstTabelas.Items.Clear()

            DBServer = txtHost.Text
            DBServerPort = "3306"
            DBDatabase = "information_schema"
            DBUser = txtUsuario.Text
            DBPass = txtSenha.Text

            MyConString = "SERVER=" & DBServer & ";DATABASE=" & DBDatabase & ";UID=" & DBUser & ";PASSWORD=" & DBPass & ";Allow Zero Datetime=True"
            Dim connection As New MySqlConnection(MyConString)
            Dim tablesCommand As MySqlCommand = connection.CreateCommand()
            Dim rowsCommand As MySqlCommand = connection.CreateCommand()
            Dim tablesReader As MySqlDataReader

            stringItem = "Explorando Bancos de dados do Servidor "
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            Application.DoEvents()
            tablesCommand.CommandText = "SELECT `SCHEMA_NAME` FROM `information_schema`.`SCHEMATA` where `SCHEMA_NAME` <> 'information_schema' order by `SCHEMA_NAME` LIMIT 0, 1000;"
            connection.Open()
            tablesReader = tablesCommand.ExecuteReader()
            Dim query As String = ""
            Dim tablesArray As New ArrayList()
            Dim zebralist As Boolean
            While tablesReader.Read()
                stringItem = "Adicionando banco " & tablesReader.GetValue(0).ToString() & " ao Processo"
                item = New ListViewItem(New String() {stringItem})
                lstProgresso.Items.Add(item).ForeColor = Color.Red
                lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)

                stringItem = tablesReader.GetValue(0).ToString()
                item = New ListViewItem(New String() {stringItem})
                lstBancos.Items.Add(item).ForeColor = Color.Blue
                If zebralist = False Then
                    lstBancos.Items(lstBancos.Items.Count - 1).BackColor = Color.LightGray
                    zebralist = True
                Else
                    'lstBancos.Items(lstBancos.Items.Count - 1).BackColor = Color.Gray
                    zebralist = False
                End If
                tablesArray.Add(tablesReader.GetValue(0).ToString())
                Application.DoEvents()
            End While
            tablesReader.Close()
            stringItem = "Total de bancos relacionados " & tablesArray.Count - 1
            item = New ListViewItem(New String() {stringItem})
            lstProgresso.Items.Add(item).ForeColor = Color.Red
            Application.DoEvents()
        Catch ex As MySqlException
            lblProcesso.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub btnZeraDados_Click(sender As System.Object, e As System.EventArgs) Handles btnZeraDados.Click
        Try
            Select Case MessageBox.Show("ATENÇÃO : Se prosseguir todos os dados serão apagados." & vbNewLine & "Deseja realmente continuar com o processo ?", "Apagar todos os registros", MessageBoxButtons.YesNo, MessageBoxIcon.Stop)
                Case Windows.Forms.DialogResult.Yes
                    lblInfo.Visible = True
                    lblInfo.Text = "Excluindo todos os registros...."
                    DBServer = txtHost.Text
                    DBServerPort = "3306"
                    DBDatabase = lstBancos.FocusedItem.Text
                    DBUser = txtUsuario.Text
                    DBPass = txtSenha.Text
                    MyConString = "SERVER=" & DBServer & ";DATABASE=" & DBDatabase & ";UID=" & DBUser & ";PASSWORD=" & DBPass & ";Allow Zero Datetime=True"
                    Dim connection As New MySqlConnection(MyConString)
                    Dim tablesCommand As MySqlCommand = connection.CreateCommand()
                    Dim rowsCommand As MySqlCommand = connection.CreateCommand()
                    Dim tablesReader As MySqlDataReader

                    stringItem = "Explorando tabelas do banco " & DBDatabase
                    item = New ListViewItem(New String() {stringItem})
                    lblProcesso.Text = stringItem
                    Application.DoEvents()
                    tablesCommand.CommandText = "SELECT `TABLE_NAME` AS Tabela FROM `information_schema`.TABLES  WHERE TABLE_SCHEMA = '" & DBDatabase & "' AND TABLE_TYPE = 'BASE TABLE';"
                    connection.Open()
                    tablesReader = tablesCommand.ExecuteReader()
                    Dim script As String = Nothing
                    While tablesReader.Read()
                        stringItem = "Excluindo registros da tabela " & tablesReader.GetValue(0).ToString()
                        item = New ListViewItem(New String() {stringItem})
                        lblProcesso.Text = stringItem
                        tablesArray.Add(tablesReader.GetValue(0).ToString())
                        lstProgresso.Items.Add(item).ForeColor = Color.Red
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        Application.DoEvents()
                        If tablesReader.GetValue(0).ToString().ToUpper <> "TBLACESSO" AndAlso tablesReader.GetValue(0).ToString().ToUpper <> "EMPRESA" AndAlso tablesReader.GetValue(0).ToString().ToUpper <> "SEQUENCIA" Then
                            script += "TRUNCATE `" & tablesReader.GetValue(0).ToString() & "`;"
                        End If
                    End While
                    'se quiser utilizar a mesma conexao acima deve destruir o datareader
                    'como em meu sistema tenho outras funções utilizei uma nova conexão aki.
                    myScript = New MySqlScript(script)
                    Dim Con As MySqlConnection = New MySqlConnection(MyConString)
                    myScript.Connection = Con
                    Cursor.Current = Cursors.WaitCursor
                    myScript.Execute()
                    Cursor.Current = Cursors.Default
                    lblProcesso.Text = "Processo Concluído!!!"
                    lblInfo.Visible = False
                    Application.DoEvents()
                Case Windows.Forms.DialogResult.No
            End Select
        Catch ex As Exception
            'implementar tratamento de erro aqui
            lblProcesso.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub btnRestaurarBckp_Click(sender As System.Object, e As System.EventArgs) Handles btnRestaurarBckp.Click
        lblInfo.Visible = False
        RestoreMysql()
        lblInfo.Visible = False
    End Sub

    Private Sub lstBancos_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles lstBancos.SelectedIndexChanged
        Try
            Dim i As Integer
            lstBancos.MultiSelect = False
            For i = 0 To lstBancos.Items.Count - 1
                If lstBancos.Items(i).Selected = True Then
                    lstTabelas.Items.Clear()
                    lstProgresso.Items.Clear()
                    DBDatabase = lstBancos.Items(i).Text
                    MyConString = "SERVER=" & DBServer & ";DATABASE=" & DBDatabase & ";UID=" & DBUser & ";PASSWORD=" & DBPass & ";Allow Zero Datetime=True"
                    Dim connection As New MySqlConnection(MyConString)
                    Dim tablesCommand As MySqlCommand = connection.CreateCommand()
                    Dim rowsCommand As MySqlCommand = connection.CreateCommand()
                    Dim tablesReader As MySqlDataReader

                    stringItem = "Explorando Tabelas no banco " & lstBancos.Items(i).Text
                    item = New ListViewItem(New String() {stringItem})
                    lstProgresso.Items.Add(item).ForeColor = Color.Red
                    lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                    lblProcesso.Text = stringItem
                    Application.DoEvents()
                    tablesCommand.CommandText = "SELECT `TABLE_NAME` AS Tabela FROM `information_schema`.TABLES  WHERE TABLE_SCHEMA = '" & lstBancos.Items(i).Text & "' AND TABLE_TYPE = 'BASE TABLE';"
                    connection.Open()
                    tablesReader = tablesCommand.ExecuteReader()
                    Dim query As String = ""
                    Dim tablesArray As New ArrayList()
                    Dim zebralist As Boolean
                    While tablesReader.Read()
                        stringItem = "Adicionando Tabela " & tablesReader.GetValue(0).ToString() & " ao Processo"
                        item = New ListViewItem(New String() {stringItem})
                        lstProgresso.Items.Add(item).ForeColor = Color.Black
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        lblProcesso.Text = stringItem
                        Application.DoEvents()

                        stringItem = tablesReader.GetValue(0).ToString()
                        item = New ListViewItem(New String() {stringItem})

                        lstTabelas.Items.Add(item).ForeColor = Color.Black
                        If zebralist = False Then
                            lstTabelas.Items(lstTabelas.Items.Count - 1).BackColor = Color.LightGray
                            lstProgresso.Items(lstProgresso.Items.Count - 1).BackColor = Color.LightGray
                            zebralist = True
                        Else
                            'lstBancos.Items(lstBancos.Items.Count - 1).BackColor = Color.Gray
                            zebralist = False
                        End If
                        tablesArray.Add(tablesReader.GetValue(0).ToString())
                        Application.DoEvents()
                    End While

                    stringItem = "Total de Tabelas : " & tablesArray.Count
                    item = New ListViewItem(New String() {stringItem})
                    lstProgresso.Items.Add(item).ForeColor = Color.Red
                    lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                    lblProcesso.Text = stringItem
                    Application.DoEvents()

                    stringItem = "Explorando VIEWS no banco " & lstBancos.Items(i).Text
                    item = New ListViewItem(New String() {stringItem})
                    lstProgresso.Items.Add(item).ForeColor = Color.Red
                    lblProcesso.Text = stringItem
                    Application.DoEvents()
                    tablesCommand.CommandText = "SELECT TABLE_NAME AS VIEWS FROM `information_schema`.VIEWS WHERE TABLE_SCHEMA = '" & lstBancos.Items(i).Text & "'"
                    Try
                        tablesReader = tablesCommand.ExecuteReader()
                    Catch ex As Exception
                        tablesReader.Close()
                        tablesReader = tablesCommand.ExecuteReader()
                    End Try

                    query = ""
                    tablesArray = New ArrayList()
                    zebralist = False

                    While tablesReader.Read()
                        stringItem = "Adicionando Views " & tablesReader.GetValue(0).ToString() & " ao Processo"
                        item = New ListViewItem(New String() {stringItem})
                        lstProgresso.Items.Add(item).ForeColor = Color.Blue
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        lblProcesso.Text = stringItem

                        stringItem = tablesReader.GetValue(0).ToString()
                        item = New ListViewItem(New String() {stringItem})

                        lstTabelas.Items.Add(item).ForeColor = Color.Blue
                        lstTabelas.EnsureVisible(lstTabelas.Items.Count - 1)

                        If zebralist = False Then
                            lstTabelas.Items(lstTabelas.Items.Count - 1).BackColor = Color.LightGray
                            lstProgresso.Items(lstProgresso.Items.Count - 1).BackColor = Color.LightGray
                            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                            zebralist = True
                        Else
                            zebralist = False
                        End If
                        tablesArray.Add(tablesReader.GetValue(0).ToString())
                        Application.DoEvents()
                    End While

                    'STORED PROCEDURES
                    stringItem = "Explorando STORED PROCEDURES no banco " & lstBancos.Items(i).Text
                    item = New ListViewItem(New String() {stringItem})
                    lstProgresso.Items.Add(item).ForeColor = Color.Red
                    lblProcesso.Text = stringItem
                    Application.DoEvents()
                    tablesCommand.CommandText = "SELECT `SPECIFIC_NAME` FROM `information_schema`.`ROUTINES` WHERE ROUTINE_SCHEMA = '" & lstBancos.Items(i).Text & "'"
                    Try
                        tablesReader = tablesCommand.ExecuteReader()
                    Catch ex As Exception
                        tablesReader.Close()
                        tablesReader = tablesCommand.ExecuteReader()
                    Finally
                        'implementar tratamento de erro aqui
                    End Try


                    query = ""
                    tablesArray = New ArrayList()
                    zebralist = False

                    While tablesReader.Read()
                        stringItem = "Adicionando Stored Procedure " & tablesReader.GetValue(0).ToString() & " ao Processo"
                        item = New ListViewItem(New String() {stringItem})
                        lstProgresso.Items.Add(item).ForeColor = Color.Red
                        lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                        lblProcesso.Text = stringItem

                        stringItem = tablesReader.GetValue(0).ToString()
                        item = New ListViewItem(New String() {stringItem})

                        lstTabelas.Items.Add(item).ForeColor = Color.Red
                        lstTabelas.EnsureVisible(lstTabelas.Items.Count - 1)

                        If zebralist = False Then
                            lstTabelas.Items(lstTabelas.Items.Count - 1).BackColor = Color.LightGray
                            lstProgresso.Items(lstProgresso.Items.Count - 1).BackColor = Color.LightGray
                            lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                            zebralist = True
                        Else
                            'lstBancos.Items(lstBancos.Items.Count - 1).BackColor = Color.Gray
                            zebralist = False
                        End If
                        tablesArray.Add(tablesReader.GetValue(0).ToString())
                        Application.DoEvents()
                    End While



                    tablesReader.Close()
                    stringItem = "Total de STORED PROCEDURES relacionados " & tablesArray.Count
                    item = New ListViewItem(New String() {stringItem})
                    lstProgresso.Items.Add(item).ForeColor = Color.Red
                    lstProgresso.EnsureVisible(lstProgresso.Items.Count - 1)
                    lblProcesso.Text = stringItem
                    Application.DoEvents()
                End If
            Next
        Catch ex As Exception
            'implementar tratamento de erro aqui
        End Try
    End Sub

    Private Sub rbTabela_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbTabela.CheckedChanged
        CheckBoxList(lstTabelas, Color.Black)
    End Sub

    Private Sub rbViews_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbViews.CheckedChanged
        CheckBoxList(lstTabelas, Color.Blue)
    End Sub

    Private Sub rbProcedures_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbProcedures.CheckedChanged
        CheckBoxList(lstTabelas, Color.Red)
    End Sub

    Private Sub rbTodas_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbTodas.CheckedChanged
        CheckBoxList(lstTabelas, Color.Brown)
    End Sub

    Private Sub rbDesmarcaTodas_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rbDesmarcaTodas.CheckedChanged
        CheckBoxList(lstTabelas, Color.Purple)
    End Sub
End Class