﻿Imports MySql.Data.MySqlClient
Module Uteis
    Public Function criaList(ByVal scampos As String, ByVal scondicao As String, _
                             ByVal lst As System.Windows.Forms.ListView, _
                             ByVal chkbox As Boolean, ByVal estrutura()() As String, _
                             ByVal MontaList As Boolean)
        Try
            Dim sqlstring As String, comando As String = Nothing
            If UCase(Left(scampos, 11)) = UCase("Show tables") Then

            ElseIf UCase(Left(scampos, 11)) = UCase("show fields") Then


            ElseIf UCase(Left(scampos, 11)).Length = 0 Then

            Else
                comando = "Select "
            End If
            sqlstring = comando & scampos & scondicao
            Dim i As Integer, x As Integer
            Dim campo() As String
            Dim tamanho() As String
            Dim valores() As String
            ReDim tamanho(estrutura(1).Length - 1)
            ReDim campo(estrutura(0).Length - 1)
            ReDim valores(estrutura.Length - 1)
            For i = 0 To estrutura.Length - 1
                For x = 0 To estrutura(0).Length - 1
                    If i = 0 Then
                        campo(x) = estrutura(i)(x).ToString
                    ElseIf i = 1 Then
                        tamanho(x) = estrutura(i)(x)
                    End If

                Next
            Next
            MontaListView(sqlstring, lst, campo, tamanho, True, chkbox, MontaList)
            Return Nothing
        Catch ex As Exception
            MsgBox(ex.Message & " - " & ex.StackTrace)
        End Try
        Return Nothing
    End Function

    Public Sub MontaListView(ByVal sql As String, _
                             ByVal lst As System.Windows.Forms.ListView, _
                             ByVal campos() As String, _
                             ByVal tamanho() As String, _
                             ByVal zebrado As Boolean, _
                             ByVal chkbox As Boolean, _
                             ByVal CarregaDados As Boolean)
        Try
            Dim i As Integer
            With lst
                .Items.Clear()
                .Columns.Clear()
                .View = View.Details

                For i = 0 To campos.Length - 1
                    If campos(i) = Nothing Then
                        Exit For
                    End If
                    .Columns.Add(campos(i), CInt(tamanho(i)), Windows.Forms.HorizontalAlignment.Left)
                Next
                If chkbox = True Then
                    .CheckBoxes = True
                End If
                .FullRowSelect = True
                .Sorting = SortOrder.None

                If CarregaDados = True Then
                    'System.Windows.Forms.Cursor.Current = New System.Windows.Forms.Cursor(sqlcur)
                    Dim dr As MySqlDataReader
                    'dr = cMySqlDataReader(sql)
                    Dim a As Integer
                    While dr.Read
                        Dim sequencia As String = IIf(IsDBNull(dr.Item(0)), "", dr.Item(0))
                        Dim ls As New ListViewItem(sequencia, 0)
                        For i = 1 To .Columns.Count - 1
                            If dr.IsDBNull(i) = True Then
                                ' dr.GetString()
                                ls.SubItems.Add("")
                            Else
                                If dr.GetDataTypeName(i) = "DATETIME" Then
                                    Dim idata As MySql.Data.Types.MySqlDateTime
                                    idata = dr.Item(i)
                                    ls.SubItems.Add(Format(CDate(idata), "dd/MM/yyyy"))
                                ElseIf dr.GetDataTypeName(i) = "DOUBLE" Then
                                    Dim idata As Double
                                    idata = dr.Item(i)
                                    If dr.GetName(i).ToString.ToUpper = "Qtde".ToUpper Or dr.GetName(i).ToString.ToUpper = "cmpQtde".ToUpper Then
                                        ls.SubItems.Add(idata)
                                    Else
                                        ls.SubItems.Add(FormatCurrency(idata, 2))
                                    End If

                                ElseIf dr.GetDataTypeName(i) = "DECIMAL" Then
                                    Dim idata As Double
                                    idata = dr.Item(i)
                                    ls.SubItems.Add(FormatCurrency(idata, 2))
                                Else
                                    ls.SubItems.Add(dr.Item(i))
                                End If
                                'ls.SubItems.Add(dr.Item(i))
                            End If
                        Next
                        .Items.Add(ls)
                        Try
                            If .Items(a).SubItems(2).Text.ToUpper = "BLOQUEADO" Then
                                .Items(a).ForeColor = Color.Red
                            End If

                        Catch ex As Exception

                        End Try

                        If zebrado = True Then
                            .Items(a).BackColor = System.Drawing.SystemColors.Control
                            zebrado = False
                        Else
                            zebrado = True
                        End If

                        a = a + 1

                    End While
                    dr.Close()
                    '.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent)
                    'System.Windows.Forms.Cursor.Current = Cursors.Default
                End If
            End With

        Catch ex As Exception
            MsgBox(ex.Message & " - " & ex.StackTrace)
        End Try
    End Sub

    Public Function CheckBoxList(Listv As ListView, tipo As Color)
        Dim i As Integer = 0
        For i = 0 To Listv.Items.Count - 1
            Listv.Items(i).Selected = True
            If Listv.Items(i).ForeColor = tipo Then
                Listv.Items(i).Checked = True
            ElseIf tipo = Color.Brown Then
                Listv.Items(i).Checked = True
            ElseIf tipo = Color.Purple Then
                Listv.Items(i).Checked = False
            Else
                Listv.Items(i).Checked = False
            End If
        Next
        Return Nothing
    End Function

End Module
